diff --git a/sim/avr/ChangeLog b/sim/avr/ChangeLog
index fa21734..0f52474 100644
--- a/sim/avr/ChangeLog
+++ b/sim/avr/ChangeLog
@@ -1,3 +1,7 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o and sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_close): Delete.
diff --git a/sim/avr/Makefile.in b/sim/avr/Makefile.in
index f0a9bcc..d17e915 100644
--- a/sim/avr/Makefile.in
+++ b/sim/avr/Makefile.in
@@ -20,8 +20,6 @@ SIM_OBJS = \
 	interp.o \
 	$(SIM_NEW_COMMON_OBJS) \
 	sim-hload.o \
-	sim-reason.o \
-	sim-resume.o \
-	sim-stop.o
+	sim-resume.o
 
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/bfin/ChangeLog b/sim/bfin/ChangeLog
index b0205e3..4445006 100644
--- a/sim/bfin/ChangeLog
+++ b/sim/bfin/ChangeLog
@@ -1,3 +1,8 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o, sim-reg.o, and
+	sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_close): Delete.
diff --git a/sim/bfin/Makefile.in b/sim/bfin/Makefile.in
index dc42339..817fecb 100644
--- a/sim/bfin/Makefile.in
+++ b/sim/bfin/Makefile.in
@@ -29,10 +29,7 @@ SIM_OBJS = \
 	machs.o \
 	sim-hload.o \
 	sim-model.o \
-	sim-reason.o \
-	sim-reg.o \
-	sim-resume.o \
-	sim-stop.o
+	sim-resume.o
 
 INCLUDE = bfin-sim.h
 
diff --git a/sim/common/ChangeLog b/sim/common/ChangeLog
index 151fc1b..bdb657f 100644
--- a/sim/common/ChangeLog
+++ b/sim/common/ChangeLog
@@ -1,3 +1,8 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Make-common.in (SIM_NEW_COMMON_OBJS): Add sim-reason.o, sim-reg.o,
+	and sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* Make-common.in (SIM_NEW_COMMON_OBJS): Add sim-close.o
diff --git a/sim/common/Make-common.in b/sim/common/Make-common.in
index aba97f7..1766b83 100644
--- a/sim/common/Make-common.in
+++ b/sim/common/Make-common.in
@@ -190,7 +190,10 @@ SIM_NEW_COMMON_OBJS = \
 	sim-module.o \
 	sim-options.o \
 	sim-profile.o \
+	sim-reason.o \
+	sim-reg.o \
 	sim-signal.o \
+	sim-stop.o \
 	sim-syscall.o \
 	sim-trace.o \
 	sim-utils.o \
diff --git a/sim/cr16/ChangeLog b/sim/cr16/ChangeLog
index 6f7b850..c63586a 100644
--- a/sim/cr16/ChangeLog
+++ b/sim/cr16/ChangeLog
@@ -1,5 +1,10 @@
 2015-11-15  Mike Frysinger  <vapier@gentoo.org>
 
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o, sim-reg.o, and
+	sim-stop.o.
+
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
 	* cr16_sim.h (cr16_callback): Delete.
 	* interp.c (cr16_callback): Delete.
 	(do_run): Delete cr16_callback.  Replace
diff --git a/sim/cr16/Makefile.in b/sim/cr16/Makefile.in
index a3db8da..e593218 100644
--- a/sim/cr16/Makefile.in
+++ b/sim/cr16/Makefile.in
@@ -20,10 +20,7 @@
 SIM_OBJS = \
 	$(SIM_NEW_COMMON_OBJS) \
 	sim-hload.o \
-	sim-reason.o \
-	sim-reg.o \
 	sim-resume.o \
-	sim-stop.o \
 	interp.o \
 	table.o \
 	simops.o
diff --git a/sim/cris/ChangeLog b/sim/cris/ChangeLog
index 42ff285..4bca1e1 100644
--- a/sim/cris/ChangeLog
+++ b/sim/cris/ChangeLog
@@ -1,3 +1,8 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o, sim-reg.o, and
+	sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-if.c (sim_close): Delete.
diff --git a/sim/cris/Makefile.in b/sim/cris/Makefile.in
index 945eaa6..f7762dd 100644
--- a/sim/cris/Makefile.in
+++ b/sim/cris/Makefile.in
@@ -25,9 +25,8 @@ CRISV32F_OBJS = crisv32f.o cpuv32.o decodev32.o modelv32.o mloopv32f.o
 SIM_OBJS = \
 	$(SIM_NEW_COMMON_OBJS) \
 	sim-model.o \
-	sim-reg.o \
 	cgen-utils.o cgen-trace.o cgen-scache.o \
-	cgen-run.o sim-reason.o sim-stop.o \
+	cgen-run.o \
 	sim-if.o arch.o \
 	$(CRISV10F_OBJS) \
 	$(CRISV32F_OBJS) \
diff --git a/sim/d10v/ChangeLog b/sim/d10v/ChangeLog
index f77a213..dd494c1 100644
--- a/sim/d10v/ChangeLog
+++ b/sim/d10v/ChangeLog
@@ -1,5 +1,9 @@
 2015-11-15  Mike Frysinger  <vapier@gentoo.org>
 
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o and sim-stop.o.
+
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
 	* interp.c (sim_open): Delete sim_create_inferior call.
 
 2015-11-15  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/d10v/Makefile.in b/sim/d10v/Makefile.in
index a6100de..e243066 100644
--- a/sim/d10v/Makefile.in
+++ b/sim/d10v/Makefile.in
@@ -21,9 +21,7 @@ SIM_OBJS = \
 	interp.o \
 	$(SIM_NEW_COMMON_OBJS) \
 	sim-hload.o \
-	sim-reason.o \
 	sim-resume.o \
-	sim-stop.o \
 	table.o \
 	simops.o \
 	endian.o
diff --git a/sim/frv/ChangeLog b/sim/frv/ChangeLog
index 9ebf498..b539c17 100644
--- a/sim/frv/ChangeLog
+++ b/sim/frv/ChangeLog
@@ -1,3 +1,8 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o, sim-reg.o, and
+	sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_close): Rename to ...
diff --git a/sim/frv/Makefile.in b/sim/frv/Makefile.in
index 6dc5616..62e480a 100644
--- a/sim/frv/Makefile.in
+++ b/sim/frv/Makefile.in
@@ -23,9 +23,8 @@ SIM_OBJS = \
 	$(SIM_NEW_COMMON_OBJS) \
 	sim-hload.o \
 	sim-model.o \
-	sim-reg.o \
 	cgen-utils.o cgen-trace.o cgen-scache.o cgen-fpu.o cgen-accfp.o \
-	cgen-run.o sim-reason.o sim-stop.o \
+	cgen-run.o \
 	sim-if.o arch.o \
 	$(FRV_OBJS) \
 	traps.o interrupts.o memory.o cache.o pipeline.o \
diff --git a/sim/ft32/ChangeLog b/sim/ft32/ChangeLog
index 00ddbdd..a306ffe 100644
--- a/sim/ft32/ChangeLog
+++ b/sim/ft32/ChangeLog
@@ -1,3 +1,8 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o, sim-reg.o, and
+	sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_OBJS): Delete objects listed in
diff --git a/sim/ft32/Makefile.in b/sim/ft32/Makefile.in
index 13dcfcb..090507f 100644
--- a/sim/ft32/Makefile.in
+++ b/sim/ft32/Makefile.in
@@ -22,9 +22,6 @@ SIM_OBJS = \
 	$(SIM_NEW_COMMON_OBJS) \
 	interp.o	\
 	sim-hload.o	\
-	sim-reason.o	\
-	sim-reg.o	\
-	sim-resume.o	\
-	sim-stop.o
+	sim-resume.o
 
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/h8300/ChangeLog b/sim/h8300/ChangeLog
index d9b385d..c76bf57 100644
--- a/sim/h8300/ChangeLog
+++ b/sim/h8300/ChangeLog
@@ -1,5 +1,9 @@
 2015-11-15  Mike Frysinger  <vapier@gentoo.org>
 
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o and sim-stop.o.
+
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
 	* Makefile.in (SIM_OBJS): Add sim-reason.o and sim-stop.o.
 	* compile.c (sim_stop, sim_stop_reason): Delete.
 
diff --git a/sim/h8300/Makefile.in b/sim/h8300/Makefile.in
index a7f23fb..9afbc0d 100644
--- a/sim/h8300/Makefile.in
+++ b/sim/h8300/Makefile.in
@@ -18,9 +18,7 @@
 ## COMMON_PRE_CONFIG_FRAG
 
 SIM_OBJS = compile.o \
-	$(SIM_NEW_COMMON_OBJS) \
-	sim-reason.o \
-	sim-stop.o
+	$(SIM_NEW_COMMON_OBJS)
 
 ## COMMON_POST_CONFIG_FRAG
 
diff --git a/sim/iq2000/ChangeLog b/sim/iq2000/ChangeLog
index dcb6cc5..c52689a 100644
--- a/sim/iq2000/ChangeLog
+++ b/sim/iq2000/ChangeLog
@@ -1,3 +1,8 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o, sim-reg.o, and
+	sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-if.c (sim_close): Delete.
diff --git a/sim/iq2000/Makefile.in b/sim/iq2000/Makefile.in
index 0871877..3ca3924 100644
--- a/sim/iq2000/Makefile.in
+++ b/sim/iq2000/Makefile.in
@@ -23,9 +23,8 @@ SIM_OBJS = \
 	$(SIM_NEW_COMMON_OBJS) \
 	sim-hload.o \
 	sim-model.o \
-	sim-reg.o \
 	cgen-utils.o cgen-trace.o cgen-scache.o \
-	cgen-run.o sim-reason.o sim-stop.o \
+	cgen-run.o \
 	sim-if.o arch.o \
 	$(IQ2000_OBJS)
 
diff --git a/sim/lm32/ChangeLog b/sim/lm32/ChangeLog
index e55d42f..081be37 100644
--- a/sim/lm32/ChangeLog
+++ b/sim/lm32/ChangeLog
@@ -1,3 +1,8 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o, sim-reg.o, and
+	sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_OBJS): Delete sim-signal.o.
diff --git a/sim/lm32/Makefile.in b/sim/lm32/Makefile.in
index 64e7483..91b6278 100644
--- a/sim/lm32/Makefile.in
+++ b/sim/lm32/Makefile.in
@@ -8,9 +8,8 @@ SIM_OBJS = \
 	$(SIM_NEW_COMMON_OBJS) \
 	sim-hload.o \
 	sim-model.o \
-	sim-reg.o \
         cgen-utils.o cgen-trace.o cgen-scache.o \
-        cgen-run.o sim-reason.o sim-stop.o \
+        cgen-run.o \
         sim-if.o arch.o \
         cpu.o decode.o sem.o model.o mloop.o \
         lm32.o traps.o user.o 
diff --git a/sim/m32r/ChangeLog b/sim/m32r/ChangeLog
index 8919efc..769d2ab 100644
--- a/sim/m32r/ChangeLog
+++ b/sim/m32r/ChangeLog
@@ -1,3 +1,8 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o, sim-reg.o, and
+	sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-if.c (sim_close): Delete.
diff --git a/sim/m32r/Makefile.in b/sim/m32r/Makefile.in
index 7090e5f..801db48 100644
--- a/sim/m32r/Makefile.in
+++ b/sim/m32r/Makefile.in
@@ -28,9 +28,8 @@ SIM_OBJS = \
 	$(SIM_NEW_COMMON_OBJS) \
 	sim-hload.o \
 	sim-model.o \
-	sim-reg.o \
 	cgen-utils.o cgen-trace.o cgen-scache.o \
-	cgen-run.o sim-reason.o sim-stop.o \
+	cgen-run.o \
 	sim-if.o arch.o \
 	$(M32R_OBJS) \
 	$(M32RX_OBJS) \
diff --git a/sim/m68hc11/ChangeLog b/sim/m68hc11/ChangeLog
index ba8df96..1f8d0cf 100644
--- a/sim/m68hc11/ChangeLog
+++ b/sim/m68hc11/ChangeLog
@@ -1,3 +1,7 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o and sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_OBJS): Delete sim-load.o.
diff --git a/sim/m68hc11/Makefile.in b/sim/m68hc11/Makefile.in
index f1c8048..e6aa048 100644
--- a/sim/m68hc11/Makefile.in
+++ b/sim/m68hc11/Makefile.in
@@ -23,8 +23,6 @@ M68HC11_OBJS = interp.o m68hc11int.o m68hc12int.o \
 SIM_OBJS = $(M68HC11_OBJS) \
 	$(SIM_NEW_COMMON_OBJS) \
 	sim-hload.o \
-	sim-stop.o \
-	sim-reason.o \
 	sim-resume.o
 
 SIM_PROFILE= -DPROFILE=1 -DWITH_PROFILE=-1
diff --git a/sim/mcore/ChangeLog b/sim/mcore/ChangeLog
index b85c281..d6f0cd1 100644
--- a/sim/mcore/ChangeLog
+++ b/sim/mcore/ChangeLog
@@ -1,5 +1,10 @@
 2015-11-15  Mike Frysinger  <vapier@gentoo.org>
 
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o, sim-reg.o, and
+	sim-stop.o.
+
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
 	* interp.c (mcore_regset, LAST_VALID_CREG, NUM_MCORE_REGS: Move
 	to sim-main.h.
 	(cpu): Delete.
diff --git a/sim/mcore/Makefile.in b/sim/mcore/Makefile.in
index 8e84b0e..c94e5bc 100644
--- a/sim/mcore/Makefile.in
+++ b/sim/mcore/Makefile.in
@@ -24,9 +24,6 @@ SIM_OBJS = \
 	interp.o \
 	$(SIM_NEW_COMMON_OBJS) \
 	sim-hload.o \
-	sim-reason.o \
-	sim-reg.o \
-	sim-resume.o \
-	sim-stop.o
+	sim-resume.o
 
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/microblaze/ChangeLog b/sim/microblaze/ChangeLog
index cb6f742..5712f28 100644
--- a/sim/microblaze/ChangeLog
+++ b/sim/microblaze/ChangeLog
@@ -1,3 +1,7 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o and sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_close): Delete.
diff --git a/sim/microblaze/Makefile.in b/sim/microblaze/Makefile.in
index ca4f70a..1b3e1c3 100644
--- a/sim/microblaze/Makefile.in
+++ b/sim/microblaze/Makefile.in
@@ -21,8 +21,6 @@ SIM_OBJS = \
 	interp.o \
 	$(SIM_NEW_COMMON_OBJS) \
 	sim-hload.o \
-	sim-reason.o \
-	sim-resume.o \
-	sim-stop.o
+	sim-resume.o
 
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/mips/ChangeLog b/sim/mips/ChangeLog
index 149abb1..706b0fc 100644
--- a/sim/mips/ChangeLog
+++ b/sim/mips/ChangeLog
@@ -1,3 +1,7 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o and sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_close): Rename to ...
diff --git a/sim/mips/Makefile.in b/sim/mips/Makefile.in
index f02e1bd..489e9cf 100644
--- a/sim/mips/Makefile.in
+++ b/sim/mips/Makefile.in
@@ -70,9 +70,7 @@ SIM_OBJS = \
 	dsp.o \
 	sim-main.o \
 	sim-hload.o \
-	sim-stop.o \
 	sim-resume.o \
-	sim-reason.o \
 
 
 # List of flags to always pass to $(CC).
diff --git a/sim/mn10300/ChangeLog b/sim/mn10300/ChangeLog
index e00b48f..b7a45b3 100644
--- a/sim/mn10300/ChangeLog
+++ b/sim/mn10300/ChangeLog
@@ -1,3 +1,7 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o and sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_close): Delete.
diff --git a/sim/mn10300/Makefile.in b/sim/mn10300/Makefile.in
index a85d932..2b96dd7 100644
--- a/sim/mn10300/Makefile.in
+++ b/sim/mn10300/Makefile.in
@@ -22,9 +22,7 @@ MN10300_OBJS = \
 	$(SIM_NEW_COMMON_OBJS) \
 	op_utils.o \
 	sim-hload.o \
-	sim-resume.o \
-	sim-reason.o \
-	sim-stop.o
+	sim-resume.o
 
 SIM_OBJS = $(MN10300_OBJS) interp.o
 
diff --git a/sim/moxie/ChangeLog b/sim/moxie/ChangeLog
index 9f6cfde..40fa592 100644
--- a/sim/moxie/ChangeLog
+++ b/sim/moxie/ChangeLog
@@ -1,3 +1,7 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o and sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_close): Delete.
diff --git a/sim/moxie/Makefile.in b/sim/moxie/Makefile.in
index 21dfe01..2d605f5 100644
--- a/sim/moxie/Makefile.in
+++ b/sim/moxie/Makefile.in
@@ -23,9 +23,7 @@ SIM_OBJS = \
 	$(SIM_NEW_COMMON_OBJS) \
 	interp.o \
 	sim-hload.o \
-	sim-reason.o \
-	sim-resume.o \
-	sim-stop.o
+	sim-resume.o
 
 SIM_EXTRA_LIBS = -lm -lz
 SIM_EXTRA_INSTALL = install-dtb
diff --git a/sim/msp430/ChangeLog b/sim/msp430/ChangeLog
index de174bf..eb3f8d5 100644
--- a/sim/msp430/ChangeLog
+++ b/sim/msp430/ChangeLog
@@ -1,3 +1,8 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o, sim-reg.o, and
+	sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_close): Rename to ...
diff --git a/sim/msp430/Makefile.in b/sim/msp430/Makefile.in
index 4653d97..9d687c9 100644
--- a/sim/msp430/Makefile.in
+++ b/sim/msp430/Makefile.in
@@ -29,10 +29,7 @@ SIM_OBJS = \
 	msp430-sim.o \
 	trace.o \
 	sim-hload.o \
-	sim-reason.o \
-	sim-reg.o \
-	sim-resume.o \
-	sim-stop.o \
+	sim-resume.o
 
 # List of extra dependencies.
 # Generally this consists of simulator specific files included by sim-main.h.
diff --git a/sim/sh/ChangeLog b/sim/sh/ChangeLog
index d19a881..b10484b 100644
--- a/sim/sh/ChangeLog
+++ b/sim/sh/ChangeLog
@@ -1,3 +1,7 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_close): Delete.
diff --git a/sim/sh/Makefile.in b/sim/sh/Makefile.in
index 236af86..d8f4e36 100644
--- a/sim/sh/Makefile.in
+++ b/sim/sh/Makefile.in
@@ -21,7 +21,6 @@ SIM_OBJS = \
 	interp.o \
 	$(SIM_NEW_COMMON_OBJS) \
 	sim-hload.o \
-	sim-stop.o \
 	table.o
 SIM_EXTRA_LIBS = -lm
 SIM_EXTRA_CLEAN = sh-clean
diff --git a/sim/sh64/ChangeLog b/sim/sh64/ChangeLog
index 2643913..454bfdc 100644
--- a/sim/sh64/ChangeLog
+++ b/sim/sh64/ChangeLog
@@ -1,3 +1,8 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o, sim-reg.o, and
+	sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-if.c (sim_close): Delete.
diff --git a/sim/sh64/Makefile.in b/sim/sh64/Makefile.in
index 99ed4e8..d1847bd 100644
--- a/sim/sh64/Makefile.in
+++ b/sim/sh64/Makefile.in
@@ -25,9 +25,8 @@ SIM_OBJS = \
 	$(SIM_NEW_COMMON_OBJS) \
 	sim-hload.o \
 	sim-model.o \
-	sim-reg.o \
 	cgen-utils.o cgen-trace.o cgen-scache.o \
-	cgen-run.o sim-reason.o sim-stop.o \
+	cgen-run.o \
 	sim-if.o arch.o \
 	$(SH64_OBJS)
 
diff --git a/sim/v850/ChangeLog b/sim/v850/ChangeLog
index e0b92d9..6e94282 100644
--- a/sim/v850/ChangeLog
+++ b/sim/v850/ChangeLog
@@ -1,3 +1,7 @@
+2015-11-15  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete sim-reason.o and sim-stop.o.
+
 2015-11-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_close): Delete.
diff --git a/sim/v850/Makefile.in b/sim/v850/Makefile.in
index 726ed5e..9f53fcd 100644
--- a/sim/v850/Makefile.in
+++ b/sim/v850/Makefile.in
@@ -24,9 +24,7 @@ SIM_OBJS = \
 	simops.o interp.o \
 	itable.o semantics.o idecode.o icache.o engine.o irun.o support.o \
 	sim-hload.o \
-	sim-resume.o \
-	sim-reason.o \
-	sim-stop.o
+	sim-resume.o
 
 # List of extra dependencies.
 # Generally this consists of simulator specific files included by sim-main.h.